import{S as _r,i as gr,s as br,e as o,k as c,w as f,t as a,M as qr,c as r,d as t,m as u,a as i,x as m,h as l,b as h,G as s,g as p,y as _,q as g,o as b,B as q,v as jr}from"../../chunks/vendor-hf-doc-builder.js";import{T as mr}from"../../chunks/Tip-hf-doc-builder.js";import{I as hs}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as k}from"../../chunks/CodeBlock-hf-doc-builder.js";function vr(ds){let d,x,v,w,N;return{c(){d=o("p"),x=a("\u{1F4A1} Read "),v=o("a"),w=a("LoRA: Low-Rank Adaptation of Large Language Models"),N=a(" to learn more about LoRA."),this.h()},l($){d=r($,"P",{});var E=i(d);x=l(E,"\u{1F4A1} Read "),v=r(E,"A",{href:!0,rel:!0});var C=i(v);w=l(C,"LoRA: Low-Rank Adaptation of Large Language Models"),C.forEach(t),N=l(E," to learn more about LoRA."),E.forEach(t),this.h()},h(){h(v,"href","https://arxiv.org/abs/2106.09685"),h(v,"rel","nofollow")},m($,E){p($,d,E),s(d,x),s(d,v),s(v,w),s(d,N)},d($){$&&t(d)}}}function kr(ds){let d,x,v,w,N,$,E,C,Y,le,R,G,ne,L,F,A,ke,P,J,$e;return{c(){d=o("p"),x=a("\u{1F4A1} The weight matrix is scaled by "),v=o("code"),w=a("lora_alpha/r"),N=a(", and a higher "),$=o("code"),E=a("lora_alpha"),C=a(" value assigns more weight to the LoRA activations. For performance, we recommend setting "),Y=o("code"),le=a("bias"),R=a(" to "),G=o("code"),ne=a("None"),L=a(" first, and then "),F=o("code"),A=a("lora_only"),ke=a(", before trying "),P=o("code"),J=a("all"),$e=a(".")},l(Q){d=r(Q,"P",{});var j=i(d);x=l(j,"\u{1F4A1} The weight matrix is scaled by "),v=r(j,"CODE",{});var fs=i(v);w=l(fs,"lora_alpha/r"),fs.forEach(t),N=l(j,", and a higher "),$=r(j,"CODE",{});var ms=i($);E=l(ms,"lora_alpha"),ms.forEach(t),C=l(j," value assigns more weight to the LoRA activations. For performance, we recommend setting "),Y=r(j,"CODE",{});var we=i(Y);le=l(we,"bias"),we.forEach(t),R=l(j," to "),G=r(j,"CODE",{});var W=i(G);ne=l(W,"None"),W.forEach(t),L=l(j," first, and then "),F=r(j,"CODE",{});var _s=i(F);A=l(_s,"lora_only"),_s.forEach(t),ke=l(j,", before trying "),P=r(j,"CODE",{});var ye=i(P);J=l(ye,"all"),ye.forEach(t),$e=l(j,"."),j.forEach(t)},m(Q,j){p(Q,d,j),s(d,x),s(d,v),s(v,w),s(d,N),s(d,$),s($,E),s(d,C),s(d,Y),s(Y,le),s(d,R),s(d,G),s(G,ne),s(d,L),s(d,F),s(F,A),s(d,ke),s(d,P),s(P,J),s(d,$e)},d(Q){Q&&t(d)}}}function $r(ds){let d,x,v,w,N,$,E,C,Y,le,R,G,ne,L,F,A,ke,P,J,$e,Q,j,fs,ms,we,W,_s,ye,Ee,$t,X,oe,Cs,Ae,xa,Ls,Ca,wt,gs,La,yt,D,Te,Da,Ds,Ba,Ra,Fa,Ie,Sa,Bs,Ma,Ha,Ua,Rs,Ka,Va,Fs,Ya,Et,Oe,At,Z,re,Ss,ze,Ga,Ms,Ja,Tt,ie,Qa,Ne,Wa,Xa,It,Pe,Ot,y,Za,Hs,el,sl,xe,tl,al,Us,ll,nl,Ks,ol,rl,Vs,il,pl,zt,Ce,Nt,pe,cl,Le,Ys,ul,hl,Pt,De,xt,bs,dl,Ct,Be,Lt,ee,ce,Gs,Re,fl,Js,ml,Dt,ue,_l,Qs,gl,bl,Bt,Fe,Rt,qs,ql,Ft,S,Se,jl,Me,vl,kl,$l,He,wl,Ws,yl,El,Al,Xs,Tl,St,Ue,Mt,M,Il,Ke,Ol,zl,Zs,Nl,Pl,Ht,Ve,Ut,js,xl,Kt,Ye,Vt,se,he,et,Ge,Cl,st,Ll,Yt,T,Dl,vs,Bl,Rl,tt,Fl,Sl,at,Ml,Hl,lt,Ul,Kl,Gt,Je,Jt,de,Vl,ks,Yl,Gl,Qt,I,fe,nt,Jl,Ql,ot,Wl,Xl,Zl,$s,rt,en,sn,tn,ws,it,an,ln,nn,ys,pt,on,rn,pn,me,ct,cn,un,ut,hn,dn,Wt,_e,Xt,Qe,Zt,O,fn,ht,mn,_n,dt,gn,bn,Es,qn,jn,As,vn,kn,ea,We,sa,ge,$n,Xe,wn,yn,ta,Ze,aa,z,En,ft,An,Tn,es,In,On,mt,zn,Nn,ss,Pn,xn,la,ts,na,te,be,_t,as,Cn,gt,Ln,oa,Ts,Dn,ra,ls,ia,qe,Bn,ns,Rn,Fn,pa,os,ca,ae,je,bt,rs,Sn,qt,Mn,ua,Is,Hn,ha,is,da,Os,Un,fa,ps,ma,zs,Kn,_a,cs,ga;return $=new hs({}),L=new mr({props:{$$slots:{default:[vr]},$$scope:{ctx:ds}}}),Ee=new k({props:{code:"!pip install -q peft transformers datasets evaluate seqeval",highlighted:"!pip install -q peft transformers datasets evaluate seqeval"}}),Ae=new hs({}),Oe=new k({props:{code:`from datasets import load_dataset
from transformers import (
    AutoModelForTokenClassification,
    AutoTokenizer,
    DataCollatorForTokenClassification,
    TrainingArguments,
    Trainer,
)
from peft import get_peft_config, PeftModel, PeftConfig, get_peft_model, LoraConfig, TaskType
import evaluate
import torch
import numpy as np

model_checkpoint = "roberta-large"
lr = 1e-3
batch_size = 16
num_epochs = 10`,highlighted:`<span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> (
    AutoModelForTokenClassification,
    AutoTokenizer,
    DataCollatorForTokenClassification,
    TrainingArguments,
    Trainer,
)
<span class="hljs-keyword">from</span> peft <span class="hljs-keyword">import</span> get_peft_config, PeftModel, PeftConfig, get_peft_model, LoraConfig, TaskType
<span class="hljs-keyword">import</span> evaluate
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

model_checkpoint = <span class="hljs-string">&quot;roberta-large&quot;</span>
lr = <span class="hljs-number">1e-3</span>
batch_size = <span class="hljs-number">16</span>
num_epochs = <span class="hljs-number">10</span>`}}),ze=new hs({}),Pe=new k({props:{code:`bionlp = load_dataset("tner/bionlp2004")
bionlp["train"][0]
{
    "tokens": [
        "Since",
        "HUVECs",
        "released",
        "superoxide",
        "anions",
        "in",
        "response",
        "to",
        "TNF",
        ",",
        "and",
        "H2O2",
        "induces",
        "VCAM-1",
        ",",
        "PDTC",
        "may",
        "act",
        "as",
        "a",
        "radical",
        "scavenger",
        ".",
    ],
    "tags": [0, 7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0],
}`,highlighted:`bionlp = load_dataset(<span class="hljs-string">&quot;tner/bionlp2004&quot;</span>)
bionlp[<span class="hljs-string">&quot;train&quot;</span>][<span class="hljs-number">0</span>]
{
    <span class="hljs-string">&quot;tokens&quot;</span>: [
        <span class="hljs-string">&quot;Since&quot;</span>,
        <span class="hljs-string">&quot;HUVECs&quot;</span>,
        <span class="hljs-string">&quot;released&quot;</span>,
        <span class="hljs-string">&quot;superoxide&quot;</span>,
        <span class="hljs-string">&quot;anions&quot;</span>,
        <span class="hljs-string">&quot;in&quot;</span>,
        <span class="hljs-string">&quot;response&quot;</span>,
        <span class="hljs-string">&quot;to&quot;</span>,
        <span class="hljs-string">&quot;TNF&quot;</span>,
        <span class="hljs-string">&quot;,&quot;</span>,
        <span class="hljs-string">&quot;and&quot;</span>,
        <span class="hljs-string">&quot;H2O2&quot;</span>,
        <span class="hljs-string">&quot;induces&quot;</span>,
        <span class="hljs-string">&quot;VCAM-1&quot;</span>,
        <span class="hljs-string">&quot;,&quot;</span>,
        <span class="hljs-string">&quot;PDTC&quot;</span>,
        <span class="hljs-string">&quot;may&quot;</span>,
        <span class="hljs-string">&quot;act&quot;</span>,
        <span class="hljs-string">&quot;as&quot;</span>,
        <span class="hljs-string">&quot;a&quot;</span>,
        <span class="hljs-string">&quot;radical&quot;</span>,
        <span class="hljs-string">&quot;scavenger&quot;</span>,
        <span class="hljs-string">&quot;.&quot;</span>,
    ],
    <span class="hljs-string">&quot;tags&quot;</span>: [<span class="hljs-number">0</span>, <span class="hljs-number">7</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">3</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>],
}`}}),Ce=new k({props:{code:`{
    "O": 0,
    "B-DNA": 1,
    "I-DNA": 2,
    "B-protein": 3,
    "I-protein": 4,
    "B-cell_type": 5,
    "I-cell_type": 6,
    "B-cell_line": 7,
    "I-cell_line": 8,
    "B-RNA": 9,
    "I-RNA": 10,
}`,highlighted:`{
    <span class="hljs-string">&quot;O&quot;</span>: <span class="hljs-number">0</span>,
    <span class="hljs-string">&quot;B-DNA&quot;</span>: <span class="hljs-number">1</span>,
    <span class="hljs-string">&quot;I-DNA&quot;</span>: <span class="hljs-number">2</span>,
    <span class="hljs-string">&quot;B-protein&quot;</span>: <span class="hljs-number">3</span>,
    <span class="hljs-string">&quot;I-protein&quot;</span>: <span class="hljs-number">4</span>,
    <span class="hljs-string">&quot;B-cell_type&quot;</span>: <span class="hljs-number">5</span>,
    <span class="hljs-string">&quot;I-cell_type&quot;</span>: <span class="hljs-number">6</span>,
    <span class="hljs-string">&quot;B-cell_line&quot;</span>: <span class="hljs-number">7</span>,
    <span class="hljs-string">&quot;I-cell_line&quot;</span>: <span class="hljs-number">8</span>,
    <span class="hljs-string">&quot;B-RNA&quot;</span>: <span class="hljs-number">9</span>,
    <span class="hljs-string">&quot;I-RNA&quot;</span>: <span class="hljs-number">10</span>,
}`}}),De=new k({props:{code:'seqeval = evaluate.load("seqeval")',highlighted:'seqeval = evaluate.load(<span class="hljs-string">&quot;seqeval&quot;</span>)'}}),Be=new k({props:{code:`label_list = [
    "O",
    "B-DNA",
    "I-DNA",
    "B-protein",
    "I-protein",
    "B-cell_type",
    "I-cell_type",
    "B-cell_line",
    "I-cell_line",
    "B-RNA",
    "I-RNA",
]


def compute_metrics(p):
    predictions, labels = p
    predictions = np.argmax(predictions, axis=2)

    true_predictions = [
        [label_list[p] for (p, l) in zip(prediction, label) if l != -100]
        for prediction, label in zip(predictions, labels)
    ]
    true_labels = [
        [label_list[l] for (p, l) in zip(prediction, label) if l != -100]
        for prediction, label in zip(predictions, labels)
    ]

    results = seqeval.compute(predictions=true_predictions, references=true_labels)
    return {
        "precision": results["overall_precision"],
        "recall": results["overall_recall"],
        "f1": results["overall_f1"],
        "accuracy": results["overall_accuracy"],
    }`,highlighted:`label_list = [
    <span class="hljs-string">&quot;O&quot;</span>,
    <span class="hljs-string">&quot;B-DNA&quot;</span>,
    <span class="hljs-string">&quot;I-DNA&quot;</span>,
    <span class="hljs-string">&quot;B-protein&quot;</span>,
    <span class="hljs-string">&quot;I-protein&quot;</span>,
    <span class="hljs-string">&quot;B-cell_type&quot;</span>,
    <span class="hljs-string">&quot;I-cell_type&quot;</span>,
    <span class="hljs-string">&quot;B-cell_line&quot;</span>,
    <span class="hljs-string">&quot;I-cell_line&quot;</span>,
    <span class="hljs-string">&quot;B-RNA&quot;</span>,
    <span class="hljs-string">&quot;I-RNA&quot;</span>,
]


<span class="hljs-keyword">def</span> <span class="hljs-title function_">compute_metrics</span>(<span class="hljs-params">p</span>):
    predictions, labels = p
    predictions = np.argmax(predictions, axis=<span class="hljs-number">2</span>)

    true_predictions = [
        [label_list[p] <span class="hljs-keyword">for</span> (p, l) <span class="hljs-keyword">in</span> <span class="hljs-built_in">zip</span>(prediction, label) <span class="hljs-keyword">if</span> l != -<span class="hljs-number">100</span>]
        <span class="hljs-keyword">for</span> prediction, label <span class="hljs-keyword">in</span> <span class="hljs-built_in">zip</span>(predictions, labels)
    ]
    true_labels = [
        [label_list[l] <span class="hljs-keyword">for</span> (p, l) <span class="hljs-keyword">in</span> <span class="hljs-built_in">zip</span>(prediction, label) <span class="hljs-keyword">if</span> l != -<span class="hljs-number">100</span>]
        <span class="hljs-keyword">for</span> prediction, label <span class="hljs-keyword">in</span> <span class="hljs-built_in">zip</span>(predictions, labels)
    ]

    results = seqeval.compute(predictions=true_predictions, references=true_labels)
    <span class="hljs-keyword">return</span> {
        <span class="hljs-string">&quot;precision&quot;</span>: results[<span class="hljs-string">&quot;overall_precision&quot;</span>],
        <span class="hljs-string">&quot;recall&quot;</span>: results[<span class="hljs-string">&quot;overall_recall&quot;</span>],
        <span class="hljs-string">&quot;f1&quot;</span>: results[<span class="hljs-string">&quot;overall_f1&quot;</span>],
        <span class="hljs-string">&quot;accuracy&quot;</span>: results[<span class="hljs-string">&quot;overall_accuracy&quot;</span>],
    }`}}),Re=new hs({}),Fe=new k({props:{code:"tokenizer = AutoTokenizer.from_pretrained(model_checkpoint, add_prefix_space=True)",highlighted:'tokenizer = AutoTokenizer.from_pretrained(model_checkpoint, add_prefix_space=<span class="hljs-literal">True</span>)'}}),Ue=new k({props:{code:`def tokenize_and_align_labels(examples):
    tokenized_inputs = tokenizer(examples["tokens"], truncation=True, is_split_into_words=True)

    labels = []
    for i, label in enumerate(examples[f"tags"]):
        word_ids = tokenized_inputs.word_ids(batch_index=i)
        previous_word_idx = None
        label_ids = []
        for word_idx in word_ids:
            if word_idx is None:
                label_ids.append(-100)
            elif word_idx != previous_word_idx:
                label_ids.append(label[word_idx])
            else:
                label_ids.append(-100)
            previous_word_idx = word_idx
        labels.append(label_ids)

    tokenized_inputs["labels"] = labels
    return tokenized_inputs`,highlighted:`<span class="hljs-keyword">def</span> <span class="hljs-title function_">tokenize_and_align_labels</span>(<span class="hljs-params">examples</span>):
    tokenized_inputs = tokenizer(examples[<span class="hljs-string">&quot;tokens&quot;</span>], truncation=<span class="hljs-literal">True</span>, is_split_into_words=<span class="hljs-literal">True</span>)

    labels = []
    <span class="hljs-keyword">for</span> i, label <span class="hljs-keyword">in</span> <span class="hljs-built_in">enumerate</span>(examples[<span class="hljs-string">f&quot;tags&quot;</span>]):
        word_ids = tokenized_inputs.word_ids(batch_index=i)
        previous_word_idx = <span class="hljs-literal">None</span>
        label_ids = []
        <span class="hljs-keyword">for</span> word_idx <span class="hljs-keyword">in</span> word_ids:
            <span class="hljs-keyword">if</span> word_idx <span class="hljs-keyword">is</span> <span class="hljs-literal">None</span>:
                label_ids.append(-<span class="hljs-number">100</span>)
            <span class="hljs-keyword">elif</span> word_idx != previous_word_idx:
                label_ids.append(label[word_idx])
            <span class="hljs-keyword">else</span>:
                label_ids.append(-<span class="hljs-number">100</span>)
            previous_word_idx = word_idx
        labels.append(label_ids)

    tokenized_inputs[<span class="hljs-string">&quot;labels&quot;</span>] = labels
    <span class="hljs-keyword">return</span> tokenized_inputs`}}),Ve=new k({props:{code:"tokenized_bionlp = bionlp.map(tokenize_and_align_labels, batched=True)",highlighted:'tokenized_bionlp = bionlp.<span class="hljs-built_in">map</span>(tokenize_and_align_labels, batched=<span class="hljs-literal">True</span>)'}}),Ye=new k({props:{code:"data_collator = DataCollatorForTokenClassification(tokenizer=tokenizer)",highlighted:"data_collator = DataCollatorForTokenClassification(tokenizer=tokenizer)"}}),Ge=new hs({}),Je=new k({props:{code:`id2label = {
    0: "O",
    1: "B-DNA",
    2: "I-DNA",
    3: "B-protein",
    4: "I-protein",
    5: "B-cell_type",
    6: "I-cell_type",
    7: "B-cell_line",
    8: "I-cell_line",
    9: "B-RNA",
    10: "I-RNA",
}
label2id = {
    "O": 0,
    "B-DNA": 1,
    "I-DNA": 2,
    "B-protein": 3,
    "I-protein": 4,
    "B-cell_type": 5,
    "I-cell_type": 6,
    "B-cell_line": 7,
    "I-cell_line": 8,
    "B-RNA": 9,
    "I-RNA": 10,
}

model = AutoModelForTokenClassification.from_pretrained(
    model_checkpoint, num_labels=11, id2label=id2label, label2id=label2id
)`,highlighted:`id2label = {
    <span class="hljs-number">0</span>: <span class="hljs-string">&quot;O&quot;</span>,
    <span class="hljs-number">1</span>: <span class="hljs-string">&quot;B-DNA&quot;</span>,
    <span class="hljs-number">2</span>: <span class="hljs-string">&quot;I-DNA&quot;</span>,
    <span class="hljs-number">3</span>: <span class="hljs-string">&quot;B-protein&quot;</span>,
    <span class="hljs-number">4</span>: <span class="hljs-string">&quot;I-protein&quot;</span>,
    <span class="hljs-number">5</span>: <span class="hljs-string">&quot;B-cell_type&quot;</span>,
    <span class="hljs-number">6</span>: <span class="hljs-string">&quot;I-cell_type&quot;</span>,
    <span class="hljs-number">7</span>: <span class="hljs-string">&quot;B-cell_line&quot;</span>,
    <span class="hljs-number">8</span>: <span class="hljs-string">&quot;I-cell_line&quot;</span>,
    <span class="hljs-number">9</span>: <span class="hljs-string">&quot;B-RNA&quot;</span>,
    <span class="hljs-number">10</span>: <span class="hljs-string">&quot;I-RNA&quot;</span>,
}
label2id = {
    <span class="hljs-string">&quot;O&quot;</span>: <span class="hljs-number">0</span>,
    <span class="hljs-string">&quot;B-DNA&quot;</span>: <span class="hljs-number">1</span>,
    <span class="hljs-string">&quot;I-DNA&quot;</span>: <span class="hljs-number">2</span>,
    <span class="hljs-string">&quot;B-protein&quot;</span>: <span class="hljs-number">3</span>,
    <span class="hljs-string">&quot;I-protein&quot;</span>: <span class="hljs-number">4</span>,
    <span class="hljs-string">&quot;B-cell_type&quot;</span>: <span class="hljs-number">5</span>,
    <span class="hljs-string">&quot;I-cell_type&quot;</span>: <span class="hljs-number">6</span>,
    <span class="hljs-string">&quot;B-cell_line&quot;</span>: <span class="hljs-number">7</span>,
    <span class="hljs-string">&quot;I-cell_line&quot;</span>: <span class="hljs-number">8</span>,
    <span class="hljs-string">&quot;B-RNA&quot;</span>: <span class="hljs-number">9</span>,
    <span class="hljs-string">&quot;I-RNA&quot;</span>: <span class="hljs-number">10</span>,
}

model = AutoModelForTokenClassification.from_pretrained(
    model_checkpoint, num_labels=<span class="hljs-number">11</span>, id2label=id2label, label2id=label2id
)`}}),_e=new mr({props:{$$slots:{default:[kr]},$$scope:{ctx:ds}}}),Qe=new k({props:{code:`peft_config = LoraConfig(
    task_type=TaskType.TOKEN_CLS, inference_mode=False, r=16, lora_alpha=16, lora_dropout=0.1, bias="all"
)`,highlighted:`peft_config = LoraConfig(
    task_type=TaskType.TOKEN_CLS, inference_mode=<span class="hljs-literal">False</span>, r=<span class="hljs-number">16</span>, lora_alpha=<span class="hljs-number">16</span>, lora_dropout=<span class="hljs-number">0.1</span>, bias=<span class="hljs-string">&quot;all&quot;</span>
)`}}),We=new k({props:{code:`model = get_peft_model(model, peft_config)
model.print_trainable_parameters()
"trainable params: 1855499 || all params: 355894283 || trainable%: 0.5213624069370061"`,highlighted:`model = get_peft_model(model, peft_config)
model.print_trainable_parameters()
<span class="hljs-string">&quot;trainable params: 1855499 || all params: 355894283 || trainable%: 0.5213624069370061&quot;</span>`}}),Ze=new k({props:{code:`training_args = TrainingArguments(
    output_dir="roberta-large-lora-token-classification",
    learning_rate=lr,
    per_device_train_batch_size=batch_size,
    per_device_eval_batch_size=batch_size,
    num_train_epochs=num_epochs,
    weight_decay=0.01,
    evaluation_strategy="epoch",
    save_strategy="epoch",
    load_best_model_at_end=True,
)`,highlighted:`training_args = TrainingArguments(
    output_dir=<span class="hljs-string">&quot;roberta-large-lora-token-classification&quot;</span>,
    learning_rate=lr,
    per_device_train_batch_size=batch_size,
    per_device_eval_batch_size=batch_size,
    num_train_epochs=num_epochs,
    weight_decay=<span class="hljs-number">0.01</span>,
    evaluation_strategy=<span class="hljs-string">&quot;epoch&quot;</span>,
    save_strategy=<span class="hljs-string">&quot;epoch&quot;</span>,
    load_best_model_at_end=<span class="hljs-literal">True</span>,
)`}}),ts=new k({props:{code:`trainer = Trainer(
    model=model,
    args=training_args,
    train_dataset=tokenized_bionlp["train"],
    eval_dataset=tokenized_bionlp["validation"],
    tokenizer=tokenizer,
    data_collator=data_collator,
    compute_metrics=compute_metrics,
)

trainer.train()`,highlighted:`trainer = Trainer(
    model=model,
    args=training_args,
    train_dataset=tokenized_bionlp[<span class="hljs-string">&quot;train&quot;</span>],
    eval_dataset=tokenized_bionlp[<span class="hljs-string">&quot;validation&quot;</span>],
    tokenizer=tokenizer,
    data_collator=data_collator,
    compute_metrics=compute_metrics,
)

trainer.train()`}}),as=new hs({}),ls=new k({props:{code:`from huggingface_hub import notebook_login

notebook_login()`,highlighted:`<span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> notebook_login

notebook_login()`}}),os=new k({props:{code:'model.push_to_hub("your-name/roberta-large-lora-token-classification")',highlighted:'model.push_to_hub(<span class="hljs-string">&quot;your-name/roberta-large-lora-token-classification&quot;</span>)'}}),rs=new hs({}),is=new k({props:{code:`peft_model_id = "stevhliu/roberta-large-lora-token-classification"
config = PeftConfig.from_pretrained(peft_model_id)
inference_model = AutoModelForTokenClassification.from_pretrained(
    config.base_model_name_or_path, num_labels=11, id2label=id2label, label2id=label2id
)
tokenizer = AutoTokenizer.from_pretrained(config.base_model_name_or_path)
model = PeftModel.from_pretrained(inference_model, peft_model_id)`,highlighted:`peft_model_id = <span class="hljs-string">&quot;stevhliu/roberta-large-lora-token-classification&quot;</span>
config = PeftConfig.from_pretrained(peft_model_id)
inference_model = AutoModelForTokenClassification.from_pretrained(
    config.base_model_name_or_path, num_labels=<span class="hljs-number">11</span>, id2label=id2label, label2id=label2id
)
tokenizer = AutoTokenizer.from_pretrained(config.base_model_name_or_path)
model = PeftModel.from_pretrained(inference_model, peft_model_id)`}}),ps=new k({props:{code:`text = "The activation of IL-2 gene expression and NF-kappa B through CD28 requires reactive oxygen production by 5-lipoxygenase."
inputs = tokenizer(text, return_tensors="pt")`,highlighted:`text = <span class="hljs-string">&quot;The activation of IL-2 gene expression and NF-kappa B through CD28 requires reactive oxygen production by 5-lipoxygenase.&quot;</span>
inputs = tokenizer(text, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)`}}),cs=new k({props:{code:`with torch.no_grad():
    logits = model(**inputs).logits

tokens = inputs.tokens()
predictions = torch.argmax(logits, dim=2)

for token, prediction in zip(tokens, predictions[0].numpy()):
    print((token, model.config.id2label[prediction]))
("<s>", "O")
("The", "O")
("\u0120activation", "O")
("\u0120of", "O")
("\u0120IL", "B-DNA")
("-", "O")
("2", "I-DNA")
("\u0120gene", "O")
("\u0120expression", "O")
("\u0120and", "O")
("\u0120NF", "B-protein")
("-", "O")
("k", "I-protein")
("appa", "I-protein")
("\u0120B", "I-protein")
("\u0120through", "O")
("\u0120CD", "B-protein")
("28", "I-protein")
("\u0120requires", "O")
("\u0120reactive", "O")
("\u0120oxygen", "O")
("\u0120production", "O")
("\u0120by", "O")
("\u01205", "B-protein")
("-", "O")
("lip", "I-protein")
("oxy", "I-protein")
("gen", "I-protein")
("ase", "I-protein")
(".", "O")
("</s>", "O")`,highlighted:`<span class="hljs-keyword">with</span> torch.no_grad():
    logits = model(**inputs).logits

tokens = inputs.tokens()
predictions = torch.argmax(logits, dim=<span class="hljs-number">2</span>)

<span class="hljs-keyword">for</span> token, prediction <span class="hljs-keyword">in</span> <span class="hljs-built_in">zip</span>(tokens, predictions[<span class="hljs-number">0</span>].numpy()):
    <span class="hljs-built_in">print</span>((token, model.config.id2label[prediction]))
(<span class="hljs-string">&quot;&lt;s&gt;&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;The&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;\u0120activation&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;\u0120of&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;\u0120IL&quot;</span>, <span class="hljs-string">&quot;B-DNA&quot;</span>)
(<span class="hljs-string">&quot;-&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;2&quot;</span>, <span class="hljs-string">&quot;I-DNA&quot;</span>)
(<span class="hljs-string">&quot;\u0120gene&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;\u0120expression&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;\u0120and&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;\u0120NF&quot;</span>, <span class="hljs-string">&quot;B-protein&quot;</span>)
(<span class="hljs-string">&quot;-&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;k&quot;</span>, <span class="hljs-string">&quot;I-protein&quot;</span>)
(<span class="hljs-string">&quot;appa&quot;</span>, <span class="hljs-string">&quot;I-protein&quot;</span>)
(<span class="hljs-string">&quot;\u0120B&quot;</span>, <span class="hljs-string">&quot;I-protein&quot;</span>)
(<span class="hljs-string">&quot;\u0120through&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;\u0120CD&quot;</span>, <span class="hljs-string">&quot;B-protein&quot;</span>)
(<span class="hljs-string">&quot;28&quot;</span>, <span class="hljs-string">&quot;I-protein&quot;</span>)
(<span class="hljs-string">&quot;\u0120requires&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;\u0120reactive&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;\u0120oxygen&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;\u0120production&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;\u0120by&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;\u01205&quot;</span>, <span class="hljs-string">&quot;B-protein&quot;</span>)
(<span class="hljs-string">&quot;-&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;lip&quot;</span>, <span class="hljs-string">&quot;I-protein&quot;</span>)
(<span class="hljs-string">&quot;oxy&quot;</span>, <span class="hljs-string">&quot;I-protein&quot;</span>)
(<span class="hljs-string">&quot;gen&quot;</span>, <span class="hljs-string">&quot;I-protein&quot;</span>)
(<span class="hljs-string">&quot;ase&quot;</span>, <span class="hljs-string">&quot;I-protein&quot;</span>)
(<span class="hljs-string">&quot;.&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)
(<span class="hljs-string">&quot;&lt;/s&gt;&quot;</span>, <span class="hljs-string">&quot;O&quot;</span>)`}}),{c(){d=o("meta"),x=c(),v=o("h1"),w=o("a"),N=o("span"),f($.$$.fragment),E=c(),C=o("span"),Y=a("LoRA for token classification"),le=c(),R=o("p"),G=a("Low-Rank Adaptation (LoRA) is a reparametrization method that aims to reduce the number of trainable parameters with low-rank representations. The weight matrix is broken down into low-rank matrices that are trained and updated. All the pretrained model parameters remain frozen. After training, the low-rank matrices are added back to the original weights. This makes it more efficient to store and train a LoRA model because there are significantly fewer parameters."),ne=c(),f(L.$$.fragment),F=c(),A=o("p"),ke=a("This guide will show you how to train a "),P=o("a"),J=o("code"),$e=a("roberta-large"),Q=a(" model with LoRA on the "),j=o("a"),fs=a("BioNLP2004"),ms=a(" dataset for token classification."),we=c(),W=o("p"),_s=a("Before you begin, make sure you have all the necessary libraries installed:"),ye=c(),f(Ee.$$.fragment),$t=c(),X=o("h2"),oe=o("a"),Cs=o("span"),f(Ae.$$.fragment),xa=c(),Ls=o("span"),Ca=a("Setup"),wt=c(),gs=o("p"),La=a("Let\u2019s start by importing all the necessary libraries you\u2019ll need:"),yt=c(),D=o("ul"),Te=o("li"),Da=a("\u{1F917} Transformers for loading the base "),Ds=o("code"),Ba=a("roberta-large"),Ra=a(" model and tokenizer, and handling the training loop"),Fa=c(),Ie=o("li"),Sa=a("\u{1F917} Datasets for loading and preparing the "),Bs=o("code"),Ma=a("bionlp2004"),Ha=a(" dataset for training"),Ua=c(),Rs=o("li"),Ka=a("\u{1F917} Evaluate for evaluating the model\u2019s performance"),Va=c(),Fs=o("li"),Ya=a("\u{1F917} PEFT for setting up the LoRA configuration and creating the PEFT model"),Et=c(),f(Oe.$$.fragment),At=c(),Z=o("h2"),re=o("a"),Ss=o("span"),f(ze.$$.fragment),Ga=c(),Ms=o("span"),Ja=a("Load dataset and metric"),Tt=c(),ie=o("p"),Qa=a("The "),Ne=o("a"),Wa=a("BioNLP2004"),Xa=a(" dataset includes tokens and tags for biological structures like DNA, RNA and proteins. Load the dataset:"),It=c(),f(Pe.$$.fragment),Ot=c(),y=o("p"),Za=a("The "),Hs=o("code"),el=a("tags"),sl=a(" values are defined in the label ids "),xe=o("a"),tl=a("dictionary"),al=a(". The letter that prefixes each label indicates the token position: "),Us=o("code"),ll=a("B"),nl=a(" is for the first token of an entity, "),Ks=o("code"),ol=a("I"),rl=a(" is for a token inside the entity, and "),Vs=o("code"),il=a("0"),pl=a(" is for a token that is not part of an entity."),zt=c(),f(Ce.$$.fragment),Nt=c(),pe=o("p"),cl=a("Then load the "),Le=o("a"),Ys=o("code"),ul=a("seqeval"),hl=a(" framework which includes several metrics - precision, accuracy, F1, and recall - for evaluating sequence labeling tasks."),Pt=c(),f(De.$$.fragment),xt=c(),bs=o("p"),dl=a("Now you can write an evaluation function to compute the metrics from the model predictions and labels, and return the precision, recall, F1, and accuracy scores:"),Ct=c(),f(Be.$$.fragment),Lt=c(),ee=o("h2"),ce=o("a"),Gs=o("span"),f(Re.$$.fragment),fl=c(),Js=o("span"),ml=a("Preprocess dataset"),Dt=c(),ue=o("p"),_l=a("Initialize a tokenizer and make sure you set "),Qs=o("code"),gl=a("is_split_into_words=True"),bl=a(" because the text sequence has already been split into words. However, this doesn\u2019t mean it is tokenized yet (even though it may look like it!), and you\u2019ll need to further tokenize the words into subwords."),Bt=c(),f(Fe.$$.fragment),Rt=c(),qs=o("p"),ql=a("You\u2019ll also need to write a function to:"),Ft=c(),S=o("ol"),Se=o("li"),jl=a("Map each token to their respective word with the "),Me=o("a"),vl=a("word_ids"),kl=a(" method."),$l=c(),He=o("li"),wl=a("Ignore the special tokens by setting them to "),Ws=o("code"),yl=a("-100"),El=a("."),Al=c(),Xs=o("li"),Tl=a("Label the first token of a given entity."),St=c(),f(Ue.$$.fragment),Mt=c(),M=o("p"),Il=a("Use "),Ke=o("a"),Ol=a("map"),zl=a(" to apply the "),Zs=o("code"),Nl=a("tokenize_and_align_labels"),Pl=a(" function to the dataset:"),Ht=c(),f(Ve.$$.fragment),Ut=c(),js=o("p"),xl=a("Finally, create a data collator to pad the examples to the longest length in a batch:"),Kt=c(),f(Ye.$$.fragment),Vt=c(),se=o("h2"),he=o("a"),et=o("span"),f(Ge.$$.fragment),Cl=c(),st=o("span"),Ll=a("Train"),Yt=c(),T=o("p"),Dl=a("Now you\u2019re ready to create a "),vs=o("a"),Bl=a("PeftModel"),Rl=a(". Start by loading the base "),tt=o("code"),Fl=a("roberta-large"),Sl=a(" model, the number of expected labels, and the "),at=o("code"),Ml=a("id2label"),Hl=a(" and "),lt=o("code"),Ul=a("label2id"),Kl=a(" dictionaries:"),Gt=c(),f(Je.$$.fragment),Jt=c(),de=o("p"),Vl=a("Define the "),ks=o("a"),Yl=a("LoraConfig"),Gl=a(" with:"),Qt=c(),I=o("ul"),fe=o("li"),nt=o("code"),Jl=a("task_type"),Ql=a(", token classification ("),ot=o("code"),Wl=a("TaskType.TOKEN_CLS"),Xl=a(")"),Zl=c(),$s=o("li"),rt=o("code"),en=a("r"),sn=a(", the dimension of the low-rank matrices"),tn=c(),ws=o("li"),it=o("code"),an=a("lora_alpha"),ln=a(", scaling factor for the weight matrices"),nn=c(),ys=o("li"),pt=o("code"),on=a("lora_dropout"),rn=a(", dropout probability of the LoRA layers"),pn=c(),me=o("li"),ct=o("code"),cn=a("bias"),un=a(", set to "),ut=o("code"),hn=a("all"),dn=a(" to train all bias parameters"),Wt=c(),f(_e.$$.fragment),Xt=c(),f(Qe.$$.fragment),Zt=c(),O=o("p"),fn=a("Pass the base model and "),ht=o("code"),mn=a("peft_config"),_n=a(" to the "),dt=o("code"),gn=a("get_peft_model()"),bn=a(" function to create a "),Es=o("a"),qn=a("PeftModel"),jn=a(". You can check out how much more efficient training the "),As=o("a"),vn=a("PeftModel"),kn=a(" is compared to fully training the base model by printing out the trainable parameters:"),ea=c(),f(We.$$.fragment),sa=c(),ge=o("p"),$n=a("From the \u{1F917} Transformers library, create a "),Xe=o("a"),wn=a("TrainingArguments"),yn=a(" class and specify where you want to save the model to, the training hyperparameters, how to evaluate the model, and when to save the checkpoints:"),ta=c(),f(Ze.$$.fragment),aa=c(),z=o("p"),En=a("Pass the model, "),ft=o("code"),An=a("TrainingArguments"),Tn=a(", datasets, tokenizer, data collator and evaluation function to the "),es=o("a"),In=a("Trainer"),On=a(" class. The "),mt=o("code"),zn=a("Trainer"),Nn=a(" handles the training loop for you, and when you\u2019re ready, call "),ss=o("a"),Pn=a("train"),xn=a(" to begin!"),la=c(),f(ts.$$.fragment),na=c(),te=o("h2"),be=o("a"),_t=o("span"),f(as.$$.fragment),Cn=c(),gt=o("span"),Ln=a("Share model"),oa=c(),Ts=o("p"),Dn=a("Once training is complete, you can store and share your model on the Hub if you\u2019d like. Log in to your Hugging Face account and enter your token when prompted:"),ra=c(),f(ls.$$.fragment),ia=c(),qe=o("p"),Bn=a("Upload the model to a specific model repository on the Hub with the "),ns=o("a"),Rn=a("push_to_hub"),Fn=a(" method:"),pa=c(),f(os.$$.fragment),ca=c(),ae=o("h2"),je=o("a"),bt=o("span"),f(rs.$$.fragment),Sn=c(),qt=o("span"),Mn=a("Inference"),ua=c(),Is=o("p"),Hn=a("To use your model for inference, load the configuration and model:"),ha=c(),f(is.$$.fragment),da=c(),Os=o("p"),Un=a("Get some text to tokenize:"),fa=c(),f(ps.$$.fragment),ma=c(),zs=o("p"),Kn=a("Pass the inputs to the model, and print out the model prediction for each token:"),_a=c(),f(cs.$$.fragment),this.h()},l(e){const n=qr('[data-svelte="svelte-1phssyn"]',document.head);d=r(n,"META",{name:!0,content:!0}),n.forEach(t),x=u(e),v=r(e,"H1",{class:!0});var us=i(v);w=r(us,"A",{id:!0,class:!0,href:!0});var jt=i(w);N=r(jt,"SPAN",{});var Jn=i(N);m($.$$.fragment,Jn),Jn.forEach(t),jt.forEach(t),E=u(us),C=r(us,"SPAN",{});var Qn=i(C);Y=l(Qn,"LoRA for token classification"),Qn.forEach(t),us.forEach(t),le=u(e),R=r(e,"P",{});var Wn=i(R);G=l(Wn,"Low-Rank Adaptation (LoRA) is a reparametrization method that aims to reduce the number of trainable parameters with low-rank representations. The weight matrix is broken down into low-rank matrices that are trained and updated. All the pretrained model parameters remain frozen. After training, the low-rank matrices are added back to the original weights. This makes it more efficient to store and train a LoRA model because there are significantly fewer parameters."),Wn.forEach(t),ne=u(e),m(L.$$.fragment,e),F=u(e),A=r(e,"P",{});var Ns=i(A);ke=l(Ns,"This guide will show you how to train a "),P=r(Ns,"A",{href:!0,rel:!0});var Xn=i(P);J=r(Xn,"CODE",{});var Zn=i(J);$e=l(Zn,"roberta-large"),Zn.forEach(t),Xn.forEach(t),Q=l(Ns," model with LoRA on the "),j=r(Ns,"A",{href:!0,rel:!0});var eo=i(j);fs=l(eo,"BioNLP2004"),eo.forEach(t),ms=l(Ns," dataset for token classification."),Ns.forEach(t),we=u(e),W=r(e,"P",{});var so=i(W);_s=l(so,"Before you begin, make sure you have all the necessary libraries installed:"),so.forEach(t),ye=u(e),m(Ee.$$.fragment,e),$t=u(e),X=r(e,"H2",{class:!0});var ba=i(X);oe=r(ba,"A",{id:!0,class:!0,href:!0});var to=i(oe);Cs=r(to,"SPAN",{});var ao=i(Cs);m(Ae.$$.fragment,ao),ao.forEach(t),to.forEach(t),xa=u(ba),Ls=r(ba,"SPAN",{});var lo=i(Ls);Ca=l(lo,"Setup"),lo.forEach(t),ba.forEach(t),wt=u(e),gs=r(e,"P",{});var no=i(gs);La=l(no,"Let\u2019s start by importing all the necessary libraries you\u2019ll need:"),no.forEach(t),yt=u(e),D=r(e,"UL",{});var ve=i(D);Te=r(ve,"LI",{});var qa=i(Te);Da=l(qa,"\u{1F917} Transformers for loading the base "),Ds=r(qa,"CODE",{});var oo=i(Ds);Ba=l(oo,"roberta-large"),oo.forEach(t),Ra=l(qa," model and tokenizer, and handling the training loop"),qa.forEach(t),Fa=u(ve),Ie=r(ve,"LI",{});var ja=i(Ie);Sa=l(ja,"\u{1F917} Datasets for loading and preparing the "),Bs=r(ja,"CODE",{});var ro=i(Bs);Ma=l(ro,"bionlp2004"),ro.forEach(t),Ha=l(ja," dataset for training"),ja.forEach(t),Ua=u(ve),Rs=r(ve,"LI",{});var io=i(Rs);Ka=l(io,"\u{1F917} Evaluate for evaluating the model\u2019s performance"),io.forEach(t),Va=u(ve),Fs=r(ve,"LI",{});var po=i(Fs);Ya=l(po,"\u{1F917} PEFT for setting up the LoRA configuration and creating the PEFT model"),po.forEach(t),ve.forEach(t),Et=u(e),m(Oe.$$.fragment,e),At=u(e),Z=r(e,"H2",{class:!0});var va=i(Z);re=r(va,"A",{id:!0,class:!0,href:!0});var co=i(re);Ss=r(co,"SPAN",{});var uo=i(Ss);m(ze.$$.fragment,uo),uo.forEach(t),co.forEach(t),Ga=u(va),Ms=r(va,"SPAN",{});var ho=i(Ms);Ja=l(ho,"Load dataset and metric"),ho.forEach(t),va.forEach(t),Tt=u(e),ie=r(e,"P",{});var ka=i(ie);Qa=l(ka,"The "),Ne=r(ka,"A",{href:!0,rel:!0});var fo=i(Ne);Wa=l(fo,"BioNLP2004"),fo.forEach(t),Xa=l(ka," dataset includes tokens and tags for biological structures like DNA, RNA and proteins. Load the dataset:"),ka.forEach(t),It=u(e),m(Pe.$$.fragment,e),Ot=u(e),y=r(e,"P",{});var B=i(y);Za=l(B,"The "),Hs=r(B,"CODE",{});var mo=i(Hs);el=l(mo,"tags"),mo.forEach(t),sl=l(B," values are defined in the label ids "),xe=r(B,"A",{href:!0,rel:!0});var _o=i(xe);tl=l(_o,"dictionary"),_o.forEach(t),al=l(B,". The letter that prefixes each label indicates the token position: "),Us=r(B,"CODE",{});var go=i(Us);ll=l(go,"B"),go.forEach(t),nl=l(B," is for the first token of an entity, "),Ks=r(B,"CODE",{});var bo=i(Ks);ol=l(bo,"I"),bo.forEach(t),rl=l(B," is for a token inside the entity, and "),Vs=r(B,"CODE",{});var qo=i(Vs);il=l(qo,"0"),qo.forEach(t),pl=l(B," is for a token that is not part of an entity."),B.forEach(t),zt=u(e),m(Ce.$$.fragment,e),Nt=u(e),pe=r(e,"P",{});var $a=i(pe);cl=l($a,"Then load the "),Le=r($a,"A",{href:!0,rel:!0});var jo=i(Le);Ys=r(jo,"CODE",{});var vo=i(Ys);ul=l(vo,"seqeval"),vo.forEach(t),jo.forEach(t),hl=l($a," framework which includes several metrics - precision, accuracy, F1, and recall - for evaluating sequence labeling tasks."),$a.forEach(t),Pt=u(e),m(De.$$.fragment,e),xt=u(e),bs=r(e,"P",{});var ko=i(bs);dl=l(ko,"Now you can write an evaluation function to compute the metrics from the model predictions and labels, and return the precision, recall, F1, and accuracy scores:"),ko.forEach(t),Ct=u(e),m(Be.$$.fragment,e),Lt=u(e),ee=r(e,"H2",{class:!0});var wa=i(ee);ce=r(wa,"A",{id:!0,class:!0,href:!0});var $o=i(ce);Gs=r($o,"SPAN",{});var wo=i(Gs);m(Re.$$.fragment,wo),wo.forEach(t),$o.forEach(t),fl=u(wa),Js=r(wa,"SPAN",{});var yo=i(Js);ml=l(yo,"Preprocess dataset"),yo.forEach(t),wa.forEach(t),Dt=u(e),ue=r(e,"P",{});var ya=i(ue);_l=l(ya,"Initialize a tokenizer and make sure you set "),Qs=r(ya,"CODE",{});var Eo=i(Qs);gl=l(Eo,"is_split_into_words=True"),Eo.forEach(t),bl=l(ya," because the text sequence has already been split into words. However, this doesn\u2019t mean it is tokenized yet (even though it may look like it!), and you\u2019ll need to further tokenize the words into subwords."),ya.forEach(t),Bt=u(e),m(Fe.$$.fragment,e),Rt=u(e),qs=r(e,"P",{});var Ao=i(qs);ql=l(Ao,"You\u2019ll also need to write a function to:"),Ao.forEach(t),Ft=u(e),S=r(e,"OL",{});var Ps=i(S);Se=r(Ps,"LI",{});var Ea=i(Se);jl=l(Ea,"Map each token to their respective word with the "),Me=r(Ea,"A",{href:!0,rel:!0});var To=i(Me);vl=l(To,"word_ids"),To.forEach(t),kl=l(Ea," method."),Ea.forEach(t),$l=u(Ps),He=r(Ps,"LI",{});var Aa=i(He);wl=l(Aa,"Ignore the special tokens by setting them to "),Ws=r(Aa,"CODE",{});var Io=i(Ws);yl=l(Io,"-100"),Io.forEach(t),El=l(Aa,"."),Aa.forEach(t),Al=u(Ps),Xs=r(Ps,"LI",{});var Oo=i(Xs);Tl=l(Oo,"Label the first token of a given entity."),Oo.forEach(t),Ps.forEach(t),St=u(e),m(Ue.$$.fragment,e),Mt=u(e),M=r(e,"P",{});var xs=i(M);Il=l(xs,"Use "),Ke=r(xs,"A",{href:!0,rel:!0});var zo=i(Ke);Ol=l(zo,"map"),zo.forEach(t),zl=l(xs," to apply the "),Zs=r(xs,"CODE",{});var No=i(Zs);Nl=l(No,"tokenize_and_align_labels"),No.forEach(t),Pl=l(xs," function to the dataset:"),xs.forEach(t),Ht=u(e),m(Ve.$$.fragment,e),Ut=u(e),js=r(e,"P",{});var Po=i(js);xl=l(Po,"Finally, create a data collator to pad the examples to the longest length in a batch:"),Po.forEach(t),Kt=u(e),m(Ye.$$.fragment,e),Vt=u(e),se=r(e,"H2",{class:!0});var Ta=i(se);he=r(Ta,"A",{id:!0,class:!0,href:!0});var xo=i(he);et=r(xo,"SPAN",{});var Co=i(et);m(Ge.$$.fragment,Co),Co.forEach(t),xo.forEach(t),Cl=u(Ta),st=r(Ta,"SPAN",{});var Lo=i(st);Ll=l(Lo,"Train"),Lo.forEach(t),Ta.forEach(t),Yt=u(e),T=r(e,"P",{});var H=i(T);Dl=l(H,"Now you\u2019re ready to create a "),vs=r(H,"A",{href:!0});var Do=i(vs);Bl=l(Do,"PeftModel"),Do.forEach(t),Rl=l(H,". Start by loading the base "),tt=r(H,"CODE",{});var Bo=i(tt);Fl=l(Bo,"roberta-large"),Bo.forEach(t),Sl=l(H," model, the number of expected labels, and the "),at=r(H,"CODE",{});var Ro=i(at);Ml=l(Ro,"id2label"),Ro.forEach(t),Hl=l(H," and "),lt=r(H,"CODE",{});var Fo=i(lt);Ul=l(Fo,"label2id"),Fo.forEach(t),Kl=l(H," dictionaries:"),H.forEach(t),Gt=u(e),m(Je.$$.fragment,e),Jt=u(e),de=r(e,"P",{});var Ia=i(de);Vl=l(Ia,"Define the "),ks=r(Ia,"A",{href:!0});var So=i(ks);Yl=l(So,"LoraConfig"),So.forEach(t),Gl=l(Ia," with:"),Ia.forEach(t),Qt=u(e),I=r(e,"UL",{});var U=i(I);fe=r(U,"LI",{});var vt=i(fe);nt=r(vt,"CODE",{});var Mo=i(nt);Jl=l(Mo,"task_type"),Mo.forEach(t),Ql=l(vt,", token classification ("),ot=r(vt,"CODE",{});var Ho=i(ot);Wl=l(Ho,"TaskType.TOKEN_CLS"),Ho.forEach(t),Xl=l(vt,")"),vt.forEach(t),Zl=u(U),$s=r(U,"LI",{});var Vn=i($s);rt=r(Vn,"CODE",{});var Uo=i(rt);en=l(Uo,"r"),Uo.forEach(t),sn=l(Vn,", the dimension of the low-rank matrices"),Vn.forEach(t),tn=u(U),ws=r(U,"LI",{});var Yn=i(ws);it=r(Yn,"CODE",{});var Ko=i(it);an=l(Ko,"lora_alpha"),Ko.forEach(t),ln=l(Yn,", scaling factor for the weight matrices"),Yn.forEach(t),nn=u(U),ys=r(U,"LI",{});var Gn=i(ys);pt=r(Gn,"CODE",{});var Vo=i(pt);on=l(Vo,"lora_dropout"),Vo.forEach(t),rn=l(Gn,", dropout probability of the LoRA layers"),Gn.forEach(t),pn=u(U),me=r(U,"LI",{});var kt=i(me);ct=r(kt,"CODE",{});var Yo=i(ct);cn=l(Yo,"bias"),Yo.forEach(t),un=l(kt,", set to "),ut=r(kt,"CODE",{});var Go=i(ut);hn=l(Go,"all"),Go.forEach(t),dn=l(kt," to train all bias parameters"),kt.forEach(t),U.forEach(t),Wt=u(e),m(_e.$$.fragment,e),Xt=u(e),m(Qe.$$.fragment,e),Zt=u(e),O=r(e,"P",{});var K=i(O);fn=l(K,"Pass the base model and "),ht=r(K,"CODE",{});var Jo=i(ht);mn=l(Jo,"peft_config"),Jo.forEach(t),_n=l(K," to the "),dt=r(K,"CODE",{});var Qo=i(dt);gn=l(Qo,"get_peft_model()"),Qo.forEach(t),bn=l(K," function to create a "),Es=r(K,"A",{href:!0});var Wo=i(Es);qn=l(Wo,"PeftModel"),Wo.forEach(t),jn=l(K,". You can check out how much more efficient training the "),As=r(K,"A",{href:!0});var Xo=i(As);vn=l(Xo,"PeftModel"),Xo.forEach(t),kn=l(K," is compared to fully training the base model by printing out the trainable parameters:"),K.forEach(t),ea=u(e),m(We.$$.fragment,e),sa=u(e),ge=r(e,"P",{});var Oa=i(ge);$n=l(Oa,"From the \u{1F917} Transformers library, create a "),Xe=r(Oa,"A",{href:!0,rel:!0});var Zo=i(Xe);wn=l(Zo,"TrainingArguments"),Zo.forEach(t),yn=l(Oa," class and specify where you want to save the model to, the training hyperparameters, how to evaluate the model, and when to save the checkpoints:"),Oa.forEach(t),ta=u(e),m(Ze.$$.fragment,e),aa=u(e),z=r(e,"P",{});var V=i(z);En=l(V,"Pass the model, "),ft=r(V,"CODE",{});var er=i(ft);An=l(er,"TrainingArguments"),er.forEach(t),Tn=l(V,", datasets, tokenizer, data collator and evaluation function to the "),es=r(V,"A",{href:!0,rel:!0});var sr=i(es);In=l(sr,"Trainer"),sr.forEach(t),On=l(V," class. The "),mt=r(V,"CODE",{});var tr=i(mt);zn=l(tr,"Trainer"),tr.forEach(t),Nn=l(V," handles the training loop for you, and when you\u2019re ready, call "),ss=r(V,"A",{href:!0,rel:!0});var ar=i(ss);Pn=l(ar,"train"),ar.forEach(t),xn=l(V," to begin!"),V.forEach(t),la=u(e),m(ts.$$.fragment,e),na=u(e),te=r(e,"H2",{class:!0});var za=i(te);be=r(za,"A",{id:!0,class:!0,href:!0});var lr=i(be);_t=r(lr,"SPAN",{});var nr=i(_t);m(as.$$.fragment,nr),nr.forEach(t),lr.forEach(t),Cn=u(za),gt=r(za,"SPAN",{});var or=i(gt);Ln=l(or,"Share model"),or.forEach(t),za.forEach(t),oa=u(e),Ts=r(e,"P",{});var rr=i(Ts);Dn=l(rr,"Once training is complete, you can store and share your model on the Hub if you\u2019d like. Log in to your Hugging Face account and enter your token when prompted:"),rr.forEach(t),ra=u(e),m(ls.$$.fragment,e),ia=u(e),qe=r(e,"P",{});var Na=i(qe);Bn=l(Na,"Upload the model to a specific model repository on the Hub with the "),ns=r(Na,"A",{href:!0,rel:!0});var ir=i(ns);Rn=l(ir,"push_to_hub"),ir.forEach(t),Fn=l(Na," method:"),Na.forEach(t),pa=u(e),m(os.$$.fragment,e),ca=u(e),ae=r(e,"H2",{class:!0});var Pa=i(ae);je=r(Pa,"A",{id:!0,class:!0,href:!0});var pr=i(je);bt=r(pr,"SPAN",{});var cr=i(bt);m(rs.$$.fragment,cr),cr.forEach(t),pr.forEach(t),Sn=u(Pa),qt=r(Pa,"SPAN",{});var ur=i(qt);Mn=l(ur,"Inference"),ur.forEach(t),Pa.forEach(t),ua=u(e),Is=r(e,"P",{});var hr=i(Is);Hn=l(hr,"To use your model for inference, load the configuration and model:"),hr.forEach(t),ha=u(e),m(is.$$.fragment,e),da=u(e),Os=r(e,"P",{});var dr=i(Os);Un=l(dr,"Get some text to tokenize:"),dr.forEach(t),fa=u(e),m(ps.$$.fragment,e),ma=u(e),zs=r(e,"P",{});var fr=i(zs);Kn=l(fr,"Pass the inputs to the model, and print out the model prediction for each token:"),fr.forEach(t),_a=u(e),m(cs.$$.fragment,e),this.h()},h(){h(d,"name","hf:doc:metadata"),h(d,"content",JSON.stringify(wr)),h(w,"id","lora-for-token-classification"),h(w,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(w,"href","#lora-for-token-classification"),h(v,"class","relative group"),h(P,"href","https://huggingface.co/roberta-large"),h(P,"rel","nofollow"),h(j,"href","https://huggingface.co/datasets/tner/bionlp2004"),h(j,"rel","nofollow"),h(oe,"id","setup"),h(oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(oe,"href","#setup"),h(X,"class","relative group"),h(re,"id","load-dataset-and-metric"),h(re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(re,"href","#load-dataset-and-metric"),h(Z,"class","relative group"),h(Ne,"href","https://huggingface.co/datasets/tner/bionlp2004"),h(Ne,"rel","nofollow"),h(xe,"href","https://huggingface.co/datasets/tner/bionlp2004#label-id"),h(xe,"rel","nofollow"),h(Le,"href","https://huggingface.co/spaces/evaluate-metric/seqeval"),h(Le,"rel","nofollow"),h(ce,"id","preprocess-dataset"),h(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ce,"href","#preprocess-dataset"),h(ee,"class","relative group"),h(Me,"href","https://huggingface.co/docs/transformers/main/en/main_classes/tokenizer#transformers.BatchEncoding.word_ids"),h(Me,"rel","nofollow"),h(Ke,"href","https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.map"),h(Ke,"rel","nofollow"),h(he,"id","train"),h(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(he,"href","#train"),h(se,"class","relative group"),h(vs,"href","/docs/peft/main/en/package_reference/peft_model#peft.PeftModel"),h(ks,"href","/docs/peft/main/en/package_reference/tuners#peft.LoraConfig"),h(Es,"href","/docs/peft/main/en/package_reference/peft_model#peft.PeftModel"),h(As,"href","/docs/peft/main/en/package_reference/peft_model#peft.PeftModel"),h(Xe,"href","https://huggingface.co/docs/transformers/main/en/main_classes/trainer#transformers.TrainingArguments"),h(Xe,"rel","nofollow"),h(es,"href","https://huggingface.co/docs/transformers/main/en/main_classes/trainer#transformers.Trainer"),h(es,"rel","nofollow"),h(ss,"href","https://huggingface.co/docs/transformers/main/en/main_classes/trainer#transformers.Trainer.train"),h(ss,"rel","nofollow"),h(be,"id","share-model"),h(be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(be,"href","#share-model"),h(te,"class","relative group"),h(ns,"href","https://huggingface.co/docs/transformers/main/en/main_classes/model#transformers.PreTrainedModel.push_to_hub"),h(ns,"rel","nofollow"),h(je,"id","inference"),h(je,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(je,"href","#inference"),h(ae,"class","relative group")},m(e,n){s(document.head,d),p(e,x,n),p(e,v,n),s(v,w),s(w,N),_($,N,null),s(v,E),s(v,C),s(C,Y),p(e,le,n),p(e,R,n),s(R,G),p(e,ne,n),_(L,e,n),p(e,F,n),p(e,A,n),s(A,ke),s(A,P),s(P,J),s(J,$e),s(A,Q),s(A,j),s(j,fs),s(A,ms),p(e,we,n),p(e,W,n),s(W,_s),p(e,ye,n),_(Ee,e,n),p(e,$t,n),p(e,X,n),s(X,oe),s(oe,Cs),_(Ae,Cs,null),s(X,xa),s(X,Ls),s(Ls,Ca),p(e,wt,n),p(e,gs,n),s(gs,La),p(e,yt,n),p(e,D,n),s(D,Te),s(Te,Da),s(Te,Ds),s(Ds,Ba),s(Te,Ra),s(D,Fa),s(D,Ie),s(Ie,Sa),s(Ie,Bs),s(Bs,Ma),s(Ie,Ha),s(D,Ua),s(D,Rs),s(Rs,Ka),s(D,Va),s(D,Fs),s(Fs,Ya),p(e,Et,n),_(Oe,e,n),p(e,At,n),p(e,Z,n),s(Z,re),s(re,Ss),_(ze,Ss,null),s(Z,Ga),s(Z,Ms),s(Ms,Ja),p(e,Tt,n),p(e,ie,n),s(ie,Qa),s(ie,Ne),s(Ne,Wa),s(ie,Xa),p(e,It,n),_(Pe,e,n),p(e,Ot,n),p(e,y,n),s(y,Za),s(y,Hs),s(Hs,el),s(y,sl),s(y,xe),s(xe,tl),s(y,al),s(y,Us),s(Us,ll),s(y,nl),s(y,Ks),s(Ks,ol),s(y,rl),s(y,Vs),s(Vs,il),s(y,pl),p(e,zt,n),_(Ce,e,n),p(e,Nt,n),p(e,pe,n),s(pe,cl),s(pe,Le),s(Le,Ys),s(Ys,ul),s(pe,hl),p(e,Pt,n),_(De,e,n),p(e,xt,n),p(e,bs,n),s(bs,dl),p(e,Ct,n),_(Be,e,n),p(e,Lt,n),p(e,ee,n),s(ee,ce),s(ce,Gs),_(Re,Gs,null),s(ee,fl),s(ee,Js),s(Js,ml),p(e,Dt,n),p(e,ue,n),s(ue,_l),s(ue,Qs),s(Qs,gl),s(ue,bl),p(e,Bt,n),_(Fe,e,n),p(e,Rt,n),p(e,qs,n),s(qs,ql),p(e,Ft,n),p(e,S,n),s(S,Se),s(Se,jl),s(Se,Me),s(Me,vl),s(Se,kl),s(S,$l),s(S,He),s(He,wl),s(He,Ws),s(Ws,yl),s(He,El),s(S,Al),s(S,Xs),s(Xs,Tl),p(e,St,n),_(Ue,e,n),p(e,Mt,n),p(e,M,n),s(M,Il),s(M,Ke),s(Ke,Ol),s(M,zl),s(M,Zs),s(Zs,Nl),s(M,Pl),p(e,Ht,n),_(Ve,e,n),p(e,Ut,n),p(e,js,n),s(js,xl),p(e,Kt,n),_(Ye,e,n),p(e,Vt,n),p(e,se,n),s(se,he),s(he,et),_(Ge,et,null),s(se,Cl),s(se,st),s(st,Ll),p(e,Yt,n),p(e,T,n),s(T,Dl),s(T,vs),s(vs,Bl),s(T,Rl),s(T,tt),s(tt,Fl),s(T,Sl),s(T,at),s(at,Ml),s(T,Hl),s(T,lt),s(lt,Ul),s(T,Kl),p(e,Gt,n),_(Je,e,n),p(e,Jt,n),p(e,de,n),s(de,Vl),s(de,ks),s(ks,Yl),s(de,Gl),p(e,Qt,n),p(e,I,n),s(I,fe),s(fe,nt),s(nt,Jl),s(fe,Ql),s(fe,ot),s(ot,Wl),s(fe,Xl),s(I,Zl),s(I,$s),s($s,rt),s(rt,en),s($s,sn),s(I,tn),s(I,ws),s(ws,it),s(it,an),s(ws,ln),s(I,nn),s(I,ys),s(ys,pt),s(pt,on),s(ys,rn),s(I,pn),s(I,me),s(me,ct),s(ct,cn),s(me,un),s(me,ut),s(ut,hn),s(me,dn),p(e,Wt,n),_(_e,e,n),p(e,Xt,n),_(Qe,e,n),p(e,Zt,n),p(e,O,n),s(O,fn),s(O,ht),s(ht,mn),s(O,_n),s(O,dt),s(dt,gn),s(O,bn),s(O,Es),s(Es,qn),s(O,jn),s(O,As),s(As,vn),s(O,kn),p(e,ea,n),_(We,e,n),p(e,sa,n),p(e,ge,n),s(ge,$n),s(ge,Xe),s(Xe,wn),s(ge,yn),p(e,ta,n),_(Ze,e,n),p(e,aa,n),p(e,z,n),s(z,En),s(z,ft),s(ft,An),s(z,Tn),s(z,es),s(es,In),s(z,On),s(z,mt),s(mt,zn),s(z,Nn),s(z,ss),s(ss,Pn),s(z,xn),p(e,la,n),_(ts,e,n),p(e,na,n),p(e,te,n),s(te,be),s(be,_t),_(as,_t,null),s(te,Cn),s(te,gt),s(gt,Ln),p(e,oa,n),p(e,Ts,n),s(Ts,Dn),p(e,ra,n),_(ls,e,n),p(e,ia,n),p(e,qe,n),s(qe,Bn),s(qe,ns),s(ns,Rn),s(qe,Fn),p(e,pa,n),_(os,e,n),p(e,ca,n),p(e,ae,n),s(ae,je),s(je,bt),_(rs,bt,null),s(ae,Sn),s(ae,qt),s(qt,Mn),p(e,ua,n),p(e,Is,n),s(Is,Hn),p(e,ha,n),_(is,e,n),p(e,da,n),p(e,Os,n),s(Os,Un),p(e,fa,n),_(ps,e,n),p(e,ma,n),p(e,zs,n),s(zs,Kn),p(e,_a,n),_(cs,e,n),ga=!0},p(e,[n]){const us={};n&2&&(us.$$scope={dirty:n,ctx:e}),L.$set(us);const jt={};n&2&&(jt.$$scope={dirty:n,ctx:e}),_e.$set(jt)},i(e){ga||(g($.$$.fragment,e),g(L.$$.fragment,e),g(Ee.$$.fragment,e),g(Ae.$$.fragment,e),g(Oe.$$.fragment,e),g(ze.$$.fragment,e),g(Pe.$$.fragment,e),g(Ce.$$.fragment,e),g(De.$$.fragment,e),g(Be.$$.fragment,e),g(Re.$$.fragment,e),g(Fe.$$.fragment,e),g(Ue.$$.fragment,e),g(Ve.$$.fragment,e),g(Ye.$$.fragment,e),g(Ge.$$.fragment,e),g(Je.$$.fragment,e),g(_e.$$.fragment,e),g(Qe.$$.fragment,e),g(We.$$.fragment,e),g(Ze.$$.fragment,e),g(ts.$$.fragment,e),g(as.$$.fragment,e),g(ls.$$.fragment,e),g(os.$$.fragment,e),g(rs.$$.fragment,e),g(is.$$.fragment,e),g(ps.$$.fragment,e),g(cs.$$.fragment,e),ga=!0)},o(e){b($.$$.fragment,e),b(L.$$.fragment,e),b(Ee.$$.fragment,e),b(Ae.$$.fragment,e),b(Oe.$$.fragment,e),b(ze.$$.fragment,e),b(Pe.$$.fragment,e),b(Ce.$$.fragment,e),b(De.$$.fragment,e),b(Be.$$.fragment,e),b(Re.$$.fragment,e),b(Fe.$$.fragment,e),b(Ue.$$.fragment,e),b(Ve.$$.fragment,e),b(Ye.$$.fragment,e),b(Ge.$$.fragment,e),b(Je.$$.fragment,e),b(_e.$$.fragment,e),b(Qe.$$.fragment,e),b(We.$$.fragment,e),b(Ze.$$.fragment,e),b(ts.$$.fragment,e),b(as.$$.fragment,e),b(ls.$$.fragment,e),b(os.$$.fragment,e),b(rs.$$.fragment,e),b(is.$$.fragment,e),b(ps.$$.fragment,e),b(cs.$$.fragment,e),ga=!1},d(e){t(d),e&&t(x),e&&t(v),q($),e&&t(le),e&&t(R),e&&t(ne),q(L,e),e&&t(F),e&&t(A),e&&t(we),e&&t(W),e&&t(ye),q(Ee,e),e&&t($t),e&&t(X),q(Ae),e&&t(wt),e&&t(gs),e&&t(yt),e&&t(D),e&&t(Et),q(Oe,e),e&&t(At),e&&t(Z),q(ze),e&&t(Tt),e&&t(ie),e&&t(It),q(Pe,e),e&&t(Ot),e&&t(y),e&&t(zt),q(Ce,e),e&&t(Nt),e&&t(pe),e&&t(Pt),q(De,e),e&&t(xt),e&&t(bs),e&&t(Ct),q(Be,e),e&&t(Lt),e&&t(ee),q(Re),e&&t(Dt),e&&t(ue),e&&t(Bt),q(Fe,e),e&&t(Rt),e&&t(qs),e&&t(Ft),e&&t(S),e&&t(St),q(Ue,e),e&&t(Mt),e&&t(M),e&&t(Ht),q(Ve,e),e&&t(Ut),e&&t(js),e&&t(Kt),q(Ye,e),e&&t(Vt),e&&t(se),q(Ge),e&&t(Yt),e&&t(T),e&&t(Gt),q(Je,e),e&&t(Jt),e&&t(de),e&&t(Qt),e&&t(I),e&&t(Wt),q(_e,e),e&&t(Xt),q(Qe,e),e&&t(Zt),e&&t(O),e&&t(ea),q(We,e),e&&t(sa),e&&t(ge),e&&t(ta),q(Ze,e),e&&t(aa),e&&t(z),e&&t(la),q(ts,e),e&&t(na),e&&t(te),q(as),e&&t(oa),e&&t(Ts),e&&t(ra),q(ls,e),e&&t(ia),e&&t(qe),e&&t(pa),q(os,e),e&&t(ca),e&&t(ae),q(rs),e&&t(ua),e&&t(Is),e&&t(ha),q(is,e),e&&t(da),e&&t(Os),e&&t(fa),q(ps,e),e&&t(ma),e&&t(zs),e&&t(_a),q(cs,e)}}}const wr={local:"lora-for-token-classification",sections:[{local:"setup",title:"Setup"},{local:"load-dataset-and-metric",title:"Load dataset and metric"},{local:"preprocess-dataset",title:"Preprocess dataset"},{local:"train",title:"Train"},{local:"share-model",title:"Share model"},{local:"inference",title:"Inference"}],title:"LoRA for token classification"};function yr(ds){return jr(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Or extends _r{constructor(d){super();gr(this,d,yr,$r,br,{})}}export{Or as default,wr as metadata};
